diff -urN nagios-3.3.1-orig/cgi/avail.c nagios-3.3.1/cgi/avail.c
--- nagios-3.3.1-orig/cgi/avail.c	2011-07-26 02:16:13.000000000 +0200
+++ nagios-3.3.1/cgi/avail.c	2012-01-10 08:36:39.000000000 +0100
@@ -58,6 +58,9 @@
 #define HTML_OUTPUT             0
 #define CSV_OUTPUT              1
 
+/* CSV format */
+#define CSV_LOOSE               0    /* Traditional Nagios */
+#define CSV_STRICT              1    /* Comply to RFC-4180 */
 
 /* archived state types */
 #define AS_CURRENT_STATE        -1   /* special case for initial assumed state */
@@ -263,7 +266,7 @@
 timeperiod *current_timeperiod = NULL;
 
 int output_format = HTML_OUTPUT;
-
+int csv_format = CSV_LOOSE;
 
 
 int main(int argc, char **argv) {
@@ -807,7 +810,7 @@
 			printf("<tr>");
 			printf("<td valign=top class='reportSelectSubTitle'>Output in CSV Format:</td>\n");
 			printf("<td valign=top class='reportSelectItem'>");
-			printf("<input type='checkbox' name='csvoutput' value=''>\n");
+			printf("<input type='checkbox' name='csvoutput' value=''><span style='margin:0px 2px 3px 15px;'>Comply to RCF4180:</span><input type='checkbox' name='csvstrict' value=''>\n");
 			printf("</td>\n");
 			printf("</tr>\n");
 			}
@@ -1080,7 +1083,13 @@
 	if(output_format == HTML_OUTPUT)
 		printf("Content-type: text/html\r\n\r\n");
 	else {
-		printf("Content-type: text/plain\r\n\r\n");
+		if(csv_format==CSV_STRICT) {
+			printf("Content-type: text/csv; header=present\r\n");
+			printf("Content-Disposition: attachment; filename=availability.csv\r\n\r\n");
+			}
+		else {
+			printf("Content-type: text/plain\r\n\r\n");
+			}
 		return;
 		}
 
@@ -1389,6 +1398,10 @@
 			output_format = CSV_OUTPUT;
 			}
 
+		/* we found the CSV format option */
+		else if(!strcmp(variables[x],"csvstrict"))
+			csv_format=CSV_STRICT;
+
 		/* we found the log entries option  */
 		else if(!strcmp(variables[x], "show_log_entries"))
 			show_log_entries = TRUE;
@@ -4174,13 +4187,18 @@
 		else if(output_format == CSV_OUTPUT) {
 			printf("HOST_NAME,");
 
-			printf(" TIME_UP_SCHEDULED, PERCENT_TIME_UP_SCHEDULED, PERCENT_KNOWN_TIME_UP_SCHEDULED, TIME_UP_UNSCHEDULED, PERCENT_TIME_UP_UNSCHEDULED, PERCENT_KNOWN_TIME_UP_UNSCHEDULED, TOTAL_TIME_UP, PERCENT_TOTAL_TIME_UP, PERCENT_KNOWN_TIME_UP,");
-
-			printf(" TIME_DOWN_SCHEDULED, PERCENT_TIME_DOWN_SCHEDULED, PERCENT_KNOWN_TIME_DOWN_SCHEDULED, TIME_DOWN_UNSCHEDULED, PERCENT_TIME_DOWN_UNSCHEDULED, PERCENT_KNOWN_TIME_DOWN_UNSCHEDULED, TOTAL_TIME_DOWN, PERCENT_TOTAL_TIME_DOWN, PERCENT_KNOWN_TIME_DOWN,");
-
-			printf(" TIME_UNREACHABLE_SCHEDULED, PERCENT_TIME_UNREACHABLE_SCHEDULED, PERCENT_KNOWN_TIME_UNREACHABLE_SCHEDULED, TIME_UNREACHABLE_UNSCHEDULED, PERCENT_TIME_UNREACHABLE_UNSCHEDULED, PERCENT_KNOWN_TIME_UNREACHABLE_UNSCHEDULED, TOTAL_TIME_UNREACHABLE, PERCENT_TOTAL_TIME_UNREACHABLE, PERCENT_KNOWN_TIME_UNREACHABLE,");
-
-			printf(" TIME_UNDETERMINED_NOT_RUNNING, PERCENT_TIME_UNDETERMINED_NOT_RUNNING, TIME_UNDETERMINED_NO_DATA, PERCENT_TIME_UNDETERMINED_NO_DATA, TOTAL_TIME_UNDETERMINED, PERCENT_TOTAL_TIME_UNDETERMINED\n");
+			if(csv_format==CSV_STRICT) {
+				printf("TIME_UP_SCHEDULED,PERCENT_TIME_UP_SCHEDULED,PERCENT_KNOWN_TIME_UP_SCHEDULED,TIME_UP_UNSCHEDULED,PERCENT_TIME_UP_UNSCHEDULED,PERCENT_KNOWN_TIME_UP_UNSCHEDULED,TOTAL_TIME_UP,PERCENT_TOTAL_TIME_UP,PERCENT_KNOWN_TIME_UP,");
+				printf("TIME_DOWN_SCHEDULED,PERCENT_TIME_DOWN_SCHEDULED,PERCENT_KNOWN_TIME_DOWN_SCHEDULED,TIME_DOWN_UNSCHEDULED,PERCENT_TIME_DOWN_UNSCHEDULED,PERCENT_KNOWN_TIME_DOWN_UNSCHEDULED,TOTAL_TIME_DOWN,PERCENT_TOTAL_TIME_DOWN,PERCENT_KNOWN_TIME_DOWN,");
+				printf("TIME_UNREACHABLE_SCHEDULED,PERCENT_TIME_UNREACHABLE_SCHEDULED,PERCENT_KNOWN_TIME_UNREACHABLE_SCHEDULED,TIME_UNREACHABLE_UNSCHEDULED,PERCENT_TIME_UNREACHABLE_UNSCHEDULED,PERCENT_KNOWN_TIME_UNREACHABLE_UNSCHEDULED,TOTAL_TIME_UNREACHABLE,PERCENT_TOTAL_TIME_UNREACHABLE,PERCENT_KNOWN_TIME_UNREACHABLE,");
+				printf("TIME_UNDETERMINED_NOT_RUNNING,PERCENT_TIME_UNDETERMINED_NOT_RUNNING,TIME_UNDETERMINED_NO_DATA,PERCENT_TIME_UNDETERMINED_NO_DATA,TOTAL_TIME_UNDETERMINED,PERCENT_TOTAL_TIME_UNDETERMINED\r\n");
+				}
+			else {
+				printf(" TIME_UP_SCHEDULED, PERCENT_TIME_UP_SCHEDULED, PERCENT_KNOWN_TIME_UP_SCHEDULED, TIME_UP_UNSCHEDULED, PERCENT_TIME_UP_UNSCHEDULED, PERCENT_KNOWN_TIME_UP_UNSCHEDULED, TOTAL_TIME_UP, PERCENT_TOTAL_TIME_UP, PERCENT_KNOWN_TIME_UP,");
+				printf(" TIME_DOWN_SCHEDULED, PERCENT_TIME_DOWN_SCHEDULED, PERCENT_KNOWN_TIME_DOWN_SCHEDULED, TIME_DOWN_UNSCHEDULED, PERCENT_TIME_DOWN_UNSCHEDULED, PERCENT_KNOWN_TIME_DOWN_UNSCHEDULED, TOTAL_TIME_DOWN, PERCENT_TOTAL_TIME_DOWN, PERCENT_KNOWN_TIME_DOWN,");
+				printf(" TIME_UNREACHABLE_SCHEDULED, PERCENT_TIME_UNREACHABLE_SCHEDULED, PERCENT_KNOWN_TIME_UNREACHABLE_SCHEDULED, TIME_UNREACHABLE_UNSCHEDULED, PERCENT_TIME_UNREACHABLE_UNSCHEDULED, PERCENT_KNOWN_TIME_UNREACHABLE_UNSCHEDULED, TOTAL_TIME_UNREACHABLE, PERCENT_TOTAL_TIME_UNREACHABLE, PERCENT_KNOWN_TIME_UNREACHABLE,");
+				printf(" TIME_UNDETERMINED_NOT_RUNNING, PERCENT_TIME_UNDETERMINED_NOT_RUNNING, TIME_UNDETERMINED_NO_DATA, PERCENT_TIME_UNDETERMINED_NO_DATA, TOTAL_TIME_UNDETERMINED, PERCENT_TOTAL_TIME_UNDETERMINED\n");
+				}
 			}
 
 
@@ -4278,17 +4296,32 @@
 				/* host name */
 				printf("\"%s\",", temp_subject->host_name);
 
-				/* up times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_up, percent_time_up_scheduled, percent_time_up_scheduled_known, temp_subject->time_up - temp_subject->scheduled_time_up, percent_time_up_unscheduled, percent_time_up_unscheduled_known, temp_subject->time_up, percent_time_up, percent_time_up_known);
+				if(csv_format==CSV_STRICT) {
+					/* up times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_up, percent_time_up_scheduled, percent_time_up_scheduled_known, temp_subject->time_up - temp_subject->scheduled_time_up, percent_time_up_unscheduled, percent_time_up_unscheduled_known, temp_subject->time_up, percent_time_up, percent_time_up_known);
+
+					/* down times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_down, percent_time_down_scheduled, percent_time_down_scheduled_known, temp_subject->time_down - temp_subject->scheduled_time_down, percent_time_down_unscheduled, percent_time_down_unscheduled_known, temp_subject->time_down, percent_time_down, percent_time_down_known);
+
+					/* unreachable times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_unreachable, percent_time_unreachable_scheduled, percent_time_unreachable_scheduled_known, temp_subject->time_unreachable - temp_subject->scheduled_time_unreachable, percent_time_unreachable_unscheduled, percent_time_unreachable_unscheduled_known, temp_subject->time_unreachable, percent_time_unreachable, percent_time_unreachable_known);
+
+					/* indeterminate times */
+					printf("%lu,%2.3f%%,%lu,%2.3f%%,%lu,%2.3f%%\r\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					}
+				else {
+					/* up times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_up, percent_time_up_scheduled, percent_time_up_scheduled_known, temp_subject->time_up - temp_subject->scheduled_time_up, percent_time_up_unscheduled, percent_time_up_unscheduled_known, temp_subject->time_up, percent_time_up, percent_time_up_known);
 
-				/* down times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_down, percent_time_down_scheduled, percent_time_down_scheduled_known, temp_subject->time_down - temp_subject->scheduled_time_down, percent_time_down_unscheduled, percent_time_down_unscheduled_known, temp_subject->time_down, percent_time_down, percent_time_down_known);
+					/* down times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_down, percent_time_down_scheduled, percent_time_down_scheduled_known, temp_subject->time_down - temp_subject->scheduled_time_down, percent_time_down_unscheduled, percent_time_down_unscheduled_known, temp_subject->time_down, percent_time_down, percent_time_down_known);
 
-				/* unreachable times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_unreachable, percent_time_unreachable_scheduled, percent_time_unreachable_scheduled_known, temp_subject->time_unreachable - temp_subject->scheduled_time_unreachable, percent_time_unreachable_unscheduled, percent_time_unreachable_unscheduled_known, temp_subject->time_unreachable, percent_time_unreachable, percent_time_unreachable_known);
+					/* unreachable times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_unreachable, percent_time_unreachable_scheduled, percent_time_unreachable_scheduled_known, temp_subject->time_unreachable - temp_subject->scheduled_time_unreachable, percent_time_unreachable_unscheduled, percent_time_unreachable_unscheduled_known, temp_subject->time_unreachable, percent_time_unreachable, percent_time_unreachable_known);
 
-				/* indeterminate times */
-				printf(" %lu, %2.3f%%, %lu, %2.3f%%, %lu, %2.3f%%\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					/* indeterminate times */
+					printf(" %lu, %2.3f%%, %lu, %2.3f%%, %lu, %2.3f%%\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					}
 				}
 
 			get_running_average(&average_percent_time_up, percent_time_up, current_subject);
@@ -4577,17 +4610,22 @@
 			printf("<TR><TH CLASS='data'>Host</TH><TH CLASS='data'>Service</TH><TH CLASS='data'>%% Time OK</TH><TH CLASS='data'>%% Time Warning</TH><TH CLASS='data'>%% Time Unknown</TH><TH CLASS='data'>%% Time Critical</TH><TH CLASS='data'>%% Time Undetermined</TH></TR>\n");
 			}
 		else if(output_format == CSV_OUTPUT) {
-			printf("HOST_NAME, SERVICE_DESCRIPTION,");
-
-			printf(" TIME_OK_SCHEDULED, PERCENT_TIME_OK_SCHEDULED, PERCENT_KNOWN_TIME_OK_SCHEDULED, TIME_OK_UNSCHEDULED, PERCENT_TIME_OK_UNSCHEDULED, PERCENT_KNOWN_TIME_OK_UNSCHEDULED, TOTAL_TIME_OK, PERCENT_TOTAL_TIME_OK, PERCENT_KNOWN_TIME_OK,");
-
-			printf(" TIME_WARNING_SCHEDULED, PERCENT_TIME_WARNING_SCHEDULED, PERCENT_KNOWN_TIME_WARNING_SCHEDULED, TIME_WARNING_UNSCHEDULED, PERCENT_TIME_WARNING_UNSCHEDULED, PERCENT_KNOWN_TIME_WARNING_UNSCHEDULED, TOTAL_TIME_WARNING, PERCENT_TOTAL_TIME_WARNING, PERCENT_KNOWN_TIME_WARNING,");
-
-			printf(" TIME_UNKNOWN_SCHEDULED, PERCENT_TIME_UNKNOWN_SCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_SCHEDULED, TIME_UNKNOWN_UNSCHEDULED, PERCENT_TIME_UNKNOWN_UNSCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_UNSCHEDULED, TOTAL_TIME_UNKNOWN, PERCENT_TOTAL_TIME_UNKNOWN, PERCENT_KNOWN_TIME_UNKNOWN,");
-
-			printf(" TIME_CRITICAL_SCHEDULED, PERCENT_TIME_CRITICAL_SCHEDULED, PERCENT_KNOWN_TIME_CRITICAL_SCHEDULED, TIME_CRITICAL_UNSCHEDULED, PERCENT_TIME_CRITICAL_UNSCHEDULED, PERCENT_KNOWN_TIME_CRITICAL_UNSCHEDULED, TOTAL_TIME_CRITICAL, PERCENT_TOTAL_TIME_CRITICAL, PERCENT_KNOWN_TIME_CRITICAL,");
-
-			printf(" TIME_UNDETERMINED_NOT_RUNNING, PERCENT_TIME_UNDETERMINED_NOT_RUNNING, TIME_UNDETERMINED_NO_DATA, PERCENT_TIME_UNDETERMINED_NO_DATA, TOTAL_TIME_UNDETERMINED, PERCENT_TOTAL_TIME_UNDETERMINED\n");
+			if(csv_format==CSV_STRICT) {
+				printf("HOST_NAME,SERVICE_DESCRIPTION,");
+				printf("TIME_OK_SCHEDULED,PERCENT_TIME_OK_SCHEDULED,PERCENT_KNOWN_TIME_OK_SCHEDULED,TIME_OK_UNSCHEDULED,PERCENT_TIME_OK_UNSCHEDULED,PERCENT_KNOWN_TIME_OK_UNSCHEDULED,TOTAL_TIME_OK,PERCENT_TOTAL_TIME_OK,PERCENT_KNOWN_TIME_OK,");
+				printf("TIME_WARNING_SCHEDULED,PERCENT_TIME_WARNING_SCHEDULED,PERCENT_KNOWN_TIME_WARNING_SCHEDULED,TIME_WARNING_UNSCHEDULED,PERCENT_TIME_WARNING_UNSCHEDULED,PERCENT_KNOWN_TIME_WARNING_UNSCHEDULED,TOTAL_TIME_WARNING,PERCENT_TOTAL_TIME_WARNING,PERCENT_KNOWN_TIME_WARNING,");
+				printf("TIME_UNKNOWN_SCHEDULED,PERCENT_TIME_UNKNOWN_SCHEDULED,PERCENT_KNOWN_TIME_UNKNOWN_SCHEDULED,TIME_UNKNOWN_UNSCHEDULED,PERCENT_TIME_UNKNOWN_UNSCHEDULED,PERCENT_KNOWN_TIME_UNKNOWN_UNSCHEDULED,TOTAL_TIME_UNKNOWN,PERCENT_TOTAL_TIME_UNKNOWN,PERCENT_KNOWN_TIME_UNKNOWN,");
+				printf("TIME_CRITICAL_SCHEDULED,PERCENT_TIME_CRITICAL_SCHEDULED,PERCENT_KNOWN_TIME_CRITICAL_SCHEDULED,TIME_CRITICAL_UNSCHEDULED,PERCENT_TIME_CRITICAL_UNSCHEDULED,PERCENT_KNOWN_TIME_CRITICAL_UNSCHEDULED,TOTAL_TIME_CRITICAL,PERCENT_TOTAL_TIME_CRITICAL,PERCENT_KNOWN_TIME_CRITICAL,");
+				printf("TIME_UNDETERMINED_NOT_RUNNING,PERCENT_TIME_UNDETERMINED_NOT_RUNNING,TIME_UNDETERMINED_NO_DATA,PERCENT_TIME_UNDETERMINED_NO_DATA,TOTAL_TIME_UNDETERMINED,PERCENT_TOTAL_TIME_UNDETERMINED\r\n");
+				}
+			else {
+				printf("HOST_NAME, SERVICE_DESCRIPTION,");
+				printf(" TIME_OK_SCHEDULED, PERCENT_TIME_OK_SCHEDULED, PERCENT_KNOWN_TIME_OK_SCHEDULED, TIME_OK_UNSCHEDULED, PERCENT_TIME_OK_UNSCHEDULED, PERCENT_KNOWN_TIME_OK_UNSCHEDULED, TOTAL_TIME_OK, PERCENT_TOTAL_TIME_OK, PERCENT_KNOWN_TIME_OK,");
+				printf(" TIME_WARNING_SCHEDULED, PERCENT_TIME_WARNING_SCHEDULED, PERCENT_KNOWN_TIME_WARNING_SCHEDULED, TIME_WARNING_UNSCHEDULED, PERCENT_TIME_WARNING_UNSCHEDULED, PERCENT_KNOWN_TIME_WARNING_UNSCHEDULED, TOTAL_TIME_WARNING, PERCENT_TOTAL_TIME_WARNING, PERCENT_KNOWN_TIME_WARNING,");
+				printf(" TIME_UNKNOWN_SCHEDULED, PERCENT_TIME_UNKNOWN_SCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_SCHEDULED, TIME_UNKNOWN_UNSCHEDULED, PERCENT_TIME_UNKNOWN_UNSCHEDULED, PERCENT_KNOWN_TIME_UNKNOWN_UNSCHEDULED, TOTAL_TIME_UNKNOWN, PERCENT_TOTAL_TIME_UNKNOWN, PERCENT_KNOWN_TIME_UNKNOWN,");
+				printf(" TIME_CRITICAL_SCHEDULED, PERCENT_TIME_CRITICAL_SCHEDULED, PERCENT_KNOWN_TIME_CRITICAL_SCHEDULED, TIME_CRITICAL_UNSCHEDULED, PERCENT_TIME_CRITICAL_UNSCHEDULED, PERCENT_KNOWN_TIME_CRITICAL_UNSCHEDULED, TOTAL_TIME_CRITICAL, PERCENT_TOTAL_TIME_CRITICAL, PERCENT_KNOWN_TIME_CRITICAL,");
+				printf(" TIME_UNDETERMINED_NOT_RUNNING, PERCENT_TIME_UNDETERMINED_NOT_RUNNING, TIME_UNDETERMINED_NO_DATA, PERCENT_TIME_UNDETERMINED_NO_DATA, TOTAL_TIME_UNDETERMINED, PERCENT_TOTAL_TIME_UNDETERMINED\n");
+				}
 			}
 
 
@@ -4696,24 +4734,44 @@
 				printf("</td><td CLASS='serviceOK'>%2.3f%% (%2.3f%%)</td><td CLASS='serviceWARNING'>%2.3f%% (%2.3f%%)</td><td CLASS='serviceUNKNOWN'>%2.3f%% (%2.3f%%)</td><td class='serviceCRITICAL'>%2.3f%% (%2.3f%%)</td><td class='data%s'>%2.3f%%</td></tr>\n", percent_time_ok, percent_time_ok_known, percent_time_warning, percent_time_warning_known, percent_time_unknown, percent_time_unknown_known, percent_time_critical, percent_time_critical_known, bgclass, percent_time_indeterminate);
 				}
 			else if(output_format == CSV_OUTPUT) {
+				if(csv_format==CSV_STRICT) {
+					/* host name and service description */
+					printf("\"%s\",\"%s\",", temp_subject->host_name, temp_subject->service_description);
+
+					/* ok times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_ok, percent_time_ok_scheduled, percent_time_ok_scheduled_known, temp_subject->time_ok - temp_subject->scheduled_time_ok, percent_time_ok_unscheduled, percent_time_ok_unscheduled_known, temp_subject->time_ok, percent_time_ok, percent_time_ok_known);
+
+					/* warning times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_warning, percent_time_warning_scheduled, percent_time_warning_scheduled_known, temp_subject->time_warning - temp_subject->scheduled_time_warning, percent_time_warning_unscheduled, percent_time_warning_unscheduled_known, temp_subject->time_warning, percent_time_warning, percent_time_warning_known);
+
+					/* unknown times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_unknown, percent_time_unknown_scheduled, percent_time_unknown_scheduled_known, temp_subject->time_unknown - temp_subject->scheduled_time_unknown, percent_time_unknown_unscheduled, percent_time_unknown_unscheduled_known, temp_subject->time_unknown, percent_time_unknown, percent_time_unknown_known);
 
-				/* host name and service description */
-				printf("\"%s\", \"%s\",", temp_subject->host_name, temp_subject->service_description);
+					/* critical times */
+					printf("%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,%lu,%2.3f%%,%2.3f%%,", temp_subject->scheduled_time_critical, percent_time_critical_scheduled, percent_time_critical_scheduled_known, temp_subject->time_critical - temp_subject->scheduled_time_critical, percent_time_critical_unscheduled, percent_time_critical_unscheduled_known, temp_subject->time_critical, percent_time_critical, percent_time_critical_known);
 
-				/* ok times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_ok, percent_time_ok_scheduled, percent_time_ok_scheduled_known, temp_subject->time_ok - temp_subject->scheduled_time_ok, percent_time_ok_unscheduled, percent_time_ok_unscheduled_known, temp_subject->time_ok, percent_time_ok, percent_time_ok_known);
+					/* indeterminate times */
+					printf("%lu,%2.3f%%,%lu,%2.3f%%,%lu,%2.3f%%\r\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					}
+				else {
+					/* host name and service description */
+					printf("\"%s\", \"%s\",", temp_subject->host_name, temp_subject->service_description);
 
-				/* warning times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_warning, percent_time_warning_scheduled, percent_time_warning_scheduled_known, temp_subject->time_warning - temp_subject->scheduled_time_warning, percent_time_warning_unscheduled, percent_time_warning_unscheduled_known, temp_subject->time_warning, percent_time_warning, percent_time_warning_known);
+					/* ok times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_ok, percent_time_ok_scheduled, percent_time_ok_scheduled_known, temp_subject->time_ok - temp_subject->scheduled_time_ok, percent_time_ok_unscheduled, percent_time_ok_unscheduled_known, temp_subject->time_ok, percent_time_ok, percent_time_ok_known);
 
-				/* unknown times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_unknown, percent_time_unknown_scheduled, percent_time_unknown_scheduled_known, temp_subject->time_unknown - temp_subject->scheduled_time_unknown, percent_time_unknown_unscheduled, percent_time_unknown_unscheduled_known, temp_subject->time_unknown, percent_time_unknown, percent_time_unknown_known);
+					/* warning times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_warning, percent_time_warning_scheduled, percent_time_warning_scheduled_known, temp_subject->time_warning - temp_subject->scheduled_time_warning, percent_time_warning_unscheduled, percent_time_warning_unscheduled_known, temp_subject->time_warning, percent_time_warning, percent_time_warning_known);
 
-				/* critical times */
-				printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_critical, percent_time_critical_scheduled, percent_time_critical_scheduled_known, temp_subject->time_critical - temp_subject->scheduled_time_critical, percent_time_critical_unscheduled, percent_time_critical_unscheduled_known, temp_subject->time_critical, percent_time_critical, percent_time_critical_known);
+					/* unknown times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_unknown, percent_time_unknown_scheduled, percent_time_unknown_scheduled_known, temp_subject->time_unknown - temp_subject->scheduled_time_unknown, percent_time_unknown_unscheduled, percent_time_unknown_unscheduled_known, temp_subject->time_unknown, percent_time_unknown, percent_time_unknown_known);
 
-				/* indeterminate times */
-				printf(" %lu, %2.3f%%, %lu, %2.3f%%, %lu, %2.3f%%\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					/* critical times */
+					printf(" %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%, %lu, %2.3f%%, %2.3f%%,", temp_subject->scheduled_time_critical, percent_time_critical_scheduled, percent_time_critical_scheduled_known, temp_subject->time_critical - temp_subject->scheduled_time_critical, percent_time_critical_unscheduled, percent_time_critical_unscheduled_known, temp_subject->time_critical, percent_time_critical, percent_time_critical_known);
+
+					/* indeterminate times */
+					printf(" %lu, %2.3f%%, %lu, %2.3f%%, %lu, %2.3f%%\n", temp_subject->time_indeterminate_notrunning, percent_time_indeterminate_notrunning, temp_subject->time_indeterminate_nodata, percent_time_indeterminate_nodata, time_indeterminate, percent_time_indeterminate);
+					}
 				}
 
 			strncpy(last_host, temp_subject->host_name, sizeof(last_host) - 1);
